Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class JavaExtensionLibrary

    java.lang.Object
      net.sf.saxon.functions.JavaExtensionLibrary

All Implemented Interfaces:
  FunctionLibrary, java.io.Serializable

public class JavaExtensionLibrary
extends java.lang.Object
implements FunctionLibrary

The JavaExtensionLibrary is a FunctionLibrary that binds XPath function calls to calls on Java methods (or constructors, or fields). It performs a mapping from the namespace URI of the function to the Java class (the mapping is partly table driven and partly algorithmic), and maps the local name of the function to the Java method, constructor, or field within the class. If the Java methods are polymorphic, then it tries to select the appropriate method based on the static types of the supplied arguments. Binding is done entirely at XPath compilation time.

See Also:
  Serialized Form

Constructor Summary
`JavaExtensionLibrary(Configuration config)` Construct a JavaExtensionLibrary and establish the default uri->class mappings.

Method Summary
`protected int` | `atomicConversionPreference(int primitiveType, java.lang.Class required)` Get the conversion preference from an XPath primitive atomic type to a Java class
`Expression` | `bind(int nameCode, java.lang.String uri, java.lang.String local, Expression[] staticArgs)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`void` | `declareJavaClass(java.lang.String uri, java.lang.Class theClass)` Declare a mapping from a specific namespace URI to a Java class
`boolean` | `isAvailable(int fingerprint, java.lang.String uri, java.lang.String local, int arity)` Test whether an extension function with a given name and arity is available.
`protected void` | `setDefaultURIMappings()` Define initial mappings of "well known" namespace URIs to Java classes (this covers the Saxon and EXSLT extensions).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JavaExtensionLibrary

    public JavaExtensionLibrary(Configuration config)

  Construct a JavaExtensionLibrary and establish the default uri->class mappings.

Parameters:
  `config` - The Saxon configuration

Method Detail

### setDefaultURIMappings

    protected void setDefaultURIMappings()

  Define initial mappings of "well known" namespace URIs to Java classes (this covers the Saxon and EXSLT extensions). The method is protected so it can be overridden in a subclass.

### declareJavaClass

    public void declareJavaClass(java.lang.String uri,
                                 java.lang.Class theClass)

  Declare a mapping from a specific namespace URI to a Java class

  Parameters:
    `uri` - the namespace URI of the function name
    `theClass` - the Java class that implements the functions in this namespace

### isAvailable

    public boolean isAvailable(int fingerprint,
                               java.lang.String uri,
                               java.lang.String local,
                               int arity)

  Test whether an extension function with a given name and arity is available. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time.

  Specified by:
    `isAvailable` in interface `FunctionLibrary`
  Parameters:
    `fingerprint` - The code that identifies the function name in the NamePool. This must match the supplied URI and local name.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some matching extension function, regardless of its arity.

### bind

    public Expression bind(int nameCode,
                           java.lang.String uri,
                           java.lang.String local,
                           Expression[] staticArgs)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `nameCode` - The namepool code of the function name. This must match the supplied URI and local name.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm.
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name, arity, or signature.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### atomicConversionPreference

    protected int atomicConversionPreference(int primitiveType,
                                             java.lang.Class required)

  Get the conversion preference from an XPath primitive atomic type to a Java class

  Parameters:
    `primitiveType` - integer code identifying the XPath primitive type, for example `Type.INTEGER` or `Type.STRING`
    `required` - The Java Class named in the method signature
  Returns:
    an integer indicating the relative preference for converting this primitive type to this Java class. A high number indicates a low preference. All values are in the range 50 to 100. For example, the conversion of an XPath String to `StringValue` is 50, while XPath String to `String` is 51. The value -1 indicates that the conversion is not allowed.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD